%Load the elephant picture 
[I,map] = imread('elephant.bmp');
imagesc(I)
colormap(map)
 
% Pick the interpolation points for the upper profile.
disp('Pick interpolation points for the upper profile of the elephant.')
[xup,yup] = ginput; % Note that the x-coordinates must be in ascending order
nup = length(xup);
yup = - yup; 
%Because of the way imagesc displays pictures, the y coordinates need to be negated to make our interpolated elephants right-side up.

% Pick the interpolation points for the lower profile, but reuse the
% end points from the upper.
 
disp('Pick interpolation points for the lower profile.')
disp('The two endpoints from the upper will be reused.')
[xlo,ylo] = ginput;
xlo = [xup(1);xlo;xup(nup)];
ylo = [yup(1);-ylo;yup(nup)];
nlo = length(xlo);
 
disp('Interpolation points for the upper profile:')
[xup,yup]

disp('Interpolation points for the lower profile:')
[xlo,ylo]
%===============================================================

%1. Polinomio interpolante della parte sopra
%punti di valutazione
xxup=linspace(min(xup),max(xup),200);
%coefficienti dell'interpolante
cup=InterpN(xup,yup);
%valori dell'interpolante
yyup=HornerN(cup,xup,xxup);
%------------------------------------------------
%2. Polinomio interpolante della parte sotto
%punti di valutazione
xxlo=linspace(min(xlo),max(xlo),200);
%coefficienti dell'interpolante
clo=InterpN(xlo,ylo);
%valori dell'interpolante
yylo=HornerN(clo,xlo,xxlo);
%-------------------------------------------------
%3. Interpolante spline cubica uniforme
%unifico i punti di interpolazione delle due parti
xt=[xup; xlo(nlo-1:-1:1)];
yt=[yup; ylo(nlo-1:-1:1)];
%parametrizzazione uniforme
n=length(xt);
t=linspace(0,1,n);
%uso 400 punti in cui valutare l'interpolazione
tt=linspace(0,1,400);
xx=spline(t,xt,tt);
yy=spline(t,yt,tt);

figure(2);
plot(xxup,yyup,'b-',xt,yt,'r-',xt,yt,'ro');
legend('Interpolante superiore','Interpolante lineare','Punti di interpolazione');

figure(3);
plot(xxlo,yylo,'c-',xt,yt,'r-',xt,yt,'ro');
legend('Interpolante inferiore','Interpolante lineare','Punti di interpolazione');

figure(4);
plot(xx,yy,'g-',xt,yt,'r-',xt,yt,'ro');
legend('Interpolante spline','Interpolante lineare','Punti di interpolazione');

